#include "types.h"
#include <cpuid.h>
#include <stdbool.h>
#include <stdint.h>

const u32 CPUID_FLAG_MSR = 1 << 5;

bool cpu_has_msr()
{
	static unsigned int eax, edx, unused;
	__get_cpuid(1, &eax, &unused, &unused, &edx);
	return edx & CPUID_FLAG_MSR;
}

void cpu_get_msr(u32 msr, u32 *lo, u32 *hi)
{
	asm volatile("rdmsr" : "=a"(*lo), "=d"(*hi) : "c"(msr));
}

void cpu_set_msr(u32 msr, u32 lo, u32 hi)
{
	asm volatile("wrmsr" : : "a"(lo), "d"(hi), "c"(msr));
}
