#include <stdint.h>

#include "string.h"
#include "terminal.h"

int print_int_base(i64 number, const char *prefix, const char *base)
{
	const int base_size = strlen(base);
	u64 div = 1;
	u32 tmp;
	int rv = 0;

	if (prefix)
		terminal_writestring(prefix);
	if (number < 0) {
		rv += terminal_putchar('-');
		tmp = -1 * number;
	} else {
		tmp = number;
	}
	while (div <= tmp / base_size)
		div *= base_size;
	while (div > 0) {
		rv += terminal_putchar(base[tmp / div % base_size]);
		div /= base_size;
	}
	return rv;
}