#include "debug.h"
#include "kprintf.h"
#include "memory.h"
void init_page_table(u32 page_table[1024], u16 start)
{
	for (u16 i = start; i < 1024; i++)
		page_table[i] = (i << 12) | 0x03;
}

i16 add_page_table(u16 pd_index)
{
	void *frame = alloc_frame();
	if (!frame)
		return -1;
	page_table_default[PT_START + pd_index] =
	    ((u32)frame & PAGE_MASK) | 0x03;
	u32 *page_table =
	    (u32 *)GET_PAGE_ADDR(0, PT_START + pd_index);
	init_page_table(page_table, 0);
	page_directory[pd_index] = ((u32)frame & PAGE_MASK) | 0x03;
	return 0;
}
